unit Unit_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ComCtrls, ToolWin, ImgList, ScktComp, StdCtrls;

type
  TMain = class(TForm)
    ActionList1: TActionList;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Connect: TAction;
    ToolButton1: TToolButton;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    Connection1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect: TAction;
    Disconnect1: TMenuItem;
    ToolButton2: TToolButton;
    Memo1: TMemo;
    E_UsrN: TEdit;
    Edit1: TEdit;
    M_UsrL: TMemo;
    C_GM: TComboBox;
    Label1: TLabel;
    PlayMode: TAction;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure UserListChange(Sender: TObject);
    procedure ConnectUpdate(Sender: TObject);
    procedure ConnectExecute(Sender: TObject);
    procedure ServerSocketListen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketGetSocket(Sender: TObject; Socket: Integer;
      var ClientSocket: TServerClientWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketLookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure DisconnectUpdate(Sender: TObject);
    procedure DisconnectExecute(Sender: TObject);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SendServer(Cmd: String; CmdData: String);
    procedure SendClient(Cmd: String; CmdData: String);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure CommonClientRead(Cmd: String; CmdData: String);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure E_UsrNExit(Sender: TObject);
    procedure E_UsrNKeyPress(Sender: TObject; var Key: Char);
    procedure C_GMSelect(Sender: TObject);
    procedure PlayModeUpdate(Sender: TObject);
    procedure PlayModeExecute(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    UserHndl: TStringList;
    UserList: TStringList;
  end;

var
  Main: TMain;

  SttsCnct: Array[0..2] of String
            = ('Disconnect','Client Mode','Server Mode');
  SttsPlay: Array[0..1] of String
            = ('Player Mode', 'GameMaster Mode');
  Zzz: Integer = 100; // Sleep(Zzz);

implementation

uses Unit_Mode, Unit_GM;

{$R *.dfm}

procedure TMain.FormCreate(Sender: TObject);
begin
  UserHndl := TStringList.Create;
  UserList := TStringList.Create;
  UserList.OnChange := UserListChange;
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
  UserList.Free;
  UserHndl.Free;
end;

procedure TMain.UserListChange(Sender: TObject);
// [U[ꗗXVꂽƂ
var
  i: Integer;
begin
  // ꗗ\XV
  M_UsrL.Lines.Assign(UserList);
  // GMꗗXV
  i := C_GM.ItemIndex;
  C_GM.Items.Assign(UserList);
  C_GM.ItemIndex := i;
{
  // T[o[hŐڑȂ
  if ServerSocket.Active then
    // V[U[ꗗSNCAgɑM
    SendClient('UserList', UserList.CommaText);
}
end;

procedure TMain.ConnectUpdate(Sender: TObject);
begin
  // ڑԂɂĎŗL/؂ւ
  (Sender as TAction).Enabled
    := not (ServerSocket.Active or ClientSocket.Active);
end;

procedure TMain.ConnectExecute(Sender: TObject);
// ڑ
begin
  // ڑݒ_CAOĂяo
  ModeDlg.E_UsrN.Text := E_UsrN.Text;
  ModeDlg.ShowModal;
  // ڑݒ_CAOƂ
  with ModeDlg do
  begin
    // ʐMJnȂ
    if ModeSelect then
    begin
      // I[h
      if SelectMode.ItemIndex = 1 then 
      // T[o[hȂ
      begin
        ServerSocket.Port := Trunc(E_Port.Value); // |[gԍw
        ServerSocket.Open; // T[oƂĒʐMI[v
        // Cxg
        //   ServerSocket.OnListen
        // NCAg̐ڑɂăCxg
        //   1 ServerSocket.OnGetSocket
        //   2 ServerSocket.OnClientConnect
        //   3 ServerSocket.OnAccept
      end
      else
      // NCAg[hȂ
      begin
        ClientSocket.Address := E_IP.Text; // IPAhXw
        ClientSocket.Port := Trunc(E_Port.Value); // |[gԍw
        ClientSocket.Open; // NCAgƂĒʐMI[v
        // Cxg
        //   1 ClientSocket.OnLookup
        //   2 ClientSocket.OnConnecting
        // ڑ̐ۂɂăCxg
        //   s = ClientSocket.OnError
        //    = ClientSocket.OnConnect
      end;
    end;
  end;
end;

procedure TMain.ServerSocketListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  // [U[ꗗXV
  UserHndl.Add('');
  UserList.Add(E_UsrN.Text);
  // GMꗗXV
  C_GM.Color := clWindow;
  C_GM.ItemIndex := 0;
  C_GM.Enabled := True;
  // TRPG[hXV
  PlayMode.Enabled := True;
end;

procedure TMain.ServerSocketGetSocket(Sender: TObject; Socket: Integer;
  var ClientSocket: TServerClientWinSocket);
begin
//
end;

procedure TMain.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//
end;

procedure TMain.ServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//
end;

procedure TMain.ClientSocketLookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//
end;

procedure TMain.ClientSocketConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//
end;

procedure TMain.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  if ErrorEvent = eeConnect then
  // NCAg[hŃT[oւ̐ڑɎsꍇ
  begin
    beep;
    MessageDlg(#13 + 'ڑł܂łB', mtError, [mbOk], 0);
    ErrorCode := 0; // ȏ̃G[\}
  end;
end;

procedure TMain.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
// NCAg[hŃT[oւ̐ڑꍇ
begin
  // [U[ꗗXV
  SendServer('AddUser', E_UsrN.Text);
  // GMꗗXV
  C_GM.Color := clWindow;
end;

procedure TMain.DisconnectUpdate(Sender: TObject);
begin
  // ڑԂɂĎŗL/؂ւ
  (Sender as TAction).Enabled
    := ServerSocket.Active or ClientSocket.Active;
  // ʐM[h̕\ؑ
  StatusBar1.Panels[0].Text := SttsCnct[
    Ord((Sender as TAction).Enabled) + Ord(ServerSocket.Active)];
end;

procedure TMain.DisconnectExecute(Sender: TObject);
// ؒf
begin
  // T[o[hŐڑȂ
  if ServerSocket.Active then
  begin
    // T[o[h̒ʐM
    ServerSocket.Close;

    // [U[ꗗXV
    UserHndl.Clear;
    UserList.Clear;
    // GMꗗXV
    C_GM.Color := clBtnFace;
    C_GM.ItemIndex := -1;
    C_GM.Enabled := False;
    // TRPG[hXV
    PlayMode.Enabled := False;
  end
  else
  // NCAg[hŐڑȂ
  if ClientSocket.Active then
  begin
    // NCAg[h̒ʐM
    ClientSocket.Close;
    // Cxg
    // ClientSocket.OnDisconnect
  end;
end;

procedure TMain.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
// NCAg[hŃT[oؒfꂽꍇ
begin
  // [U[ꗗXV
  UserHndl.Clear;
  UserList.Clear;
  // GMꗗXV
  C_GM.Color := clBtnFace;
  C_GM.ItemIndex := -1;
  // TRPG[hXV
  PlayMode.Enabled := False;
end;

procedure TMain.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
// T[o[hŃNCAg̐ڑ؂ꂽꍇ
var
  i: Integer;
begin
  // NCAg
  i := UserHndl.IndexOf( IntToStr(Socket.SocketHandle) );
  // GMꍇAT[oGM
  if C_GM.ItemIndex = i then
  begin
    // GMꗗXV
    C_GM.ItemIndex := 0;
    // TRPG[hXV
    PlayMode.Enabled := True;
  end;
  // [U[ꗗXV
  UserHndl.Delete(i); // Ǘԍj
  UserList.Delete(i); // [U[j
{
    // V[U[ꗗSNCAgɑM
    SendClient('UserList', UserList.CommaText);
    Sleep(Zzz); // R}h𕪂邽߂ɊԊu󂯂
    SendClient('GMUser', IntToStr(C_GM.ItemIndex));

//  SendClient2ƃ[v炵̂ŁA͊eNCAg
}
  // NCAgSNCAgɑM
  SendClient('Disconnect', IntToStr(i));
end;

procedure TMain.SendServer(Cmd: String; CmdData: String);
var
  s: TStringList;
begin
  s := TStringList.Create;

  s.Add(Cmd);
  s.Add(CmdData);
    ClientSocket.Socket.SendText(s.CommaText);

  s.Free;
end;

procedure TMain.SendClient(Cmd: String; CmdData: String);
var
  i: Integer;
  s: TStringList;
begin
  s := TStringList.Create;

  s.Add(Cmd);
  s.Add(CmdData);
  for i := 0 to ServerSocket.Socket.ActiveConnections - 1 do
    ServerSocket.Socket.Connections[i].SendText(s.CommaText);

  s.Free;
end;

procedure TMain.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
// T[o[hŃNCAgM
var
  i: Integer;
  s: TStringList;
begin
  s := TStringList.Create;

  s.CommaText := Socket.ReceiveText; // Mf[^擾
  if s.Count = 2 then
  begin
//Memo1.Lines.Add('* ' + s.CommaText);
    // Mf[^iT[oj
    if      s[0] = 'AddUser' then // [U[ǉ
    begin
      UserHndl.Add( IntToStr(Socket.SocketHandle) ); // Ǘԍǉ
      UserList.Add(s[1]); // [U[ǉ
      // V[U[ꗗSNCAgɑM
      SendClient('UserList', UserList.CommaText);
      Sleep(Zzz); // R}h𕪂邽߂ɊԊu󂯂
      SendClient('GMUser', IntToStr(C_GM.ItemIndex));
    end
    else if s[0] = 'ReNameUser' then // [U[ύX
    begin
      // NCAg
      i := UserHndl.IndexOf( IntToStr(Socket.SocketHandle) );
      UserList.Strings[i] := s[1]; // [U[XV
      // V[U[ꗗSNCAgɑM
      SendClient('UserList', UserList.CommaText);
    end
    else
    // Mf[^iT[oENCAgʁj
    begin
      CommonClientRead(s[0], s[1]);
      // Mf[^SNCAgɑM
      SendClient(s[0], s[1]);
    end;
  end;

  s.Free;
end;

procedure TMain.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
// NCAg[hŃT[oM
var
  i: Integer;
  s: TStringList;
begin
  s := TStringList.Create;

  s.CommaText := Socket.ReceiveText; // Mf[^擾
//Memo1.Lines.Add('* ' + s.CommaText);
  // Mf[^iNCAgj
  if     (s[0] = 'UserList') and (C_GM.ItemIndex = -1) then
  begin // ڑ̃[U[ꗗXV
    UserList.CommaText := s[1]; // [U[ꗗXV
  end
  else if s[0] = 'GMUser' then // GM[U[ύX
    C_GM.ItemIndex := StrToInt(s[1])
  else if s[0] = 'GMMode' then // TRPG[hw
    PlayMode.Enabled := (s[1] = 'True') // TRPG[hXV
  else if s[0] = 'Disconnect' then // ̃NCAgؒf
  begin
    i := StrToInt(s[1]);
    // GMꍇAT[oGM
    if C_GM.ItemIndex = i then
      // GMꗗXV
      C_GM.ItemIndex := 0;
    // [U[ꗗXV
//    UserHndl.Delete(i); // Ǘԍj NCAgł͎gĂȂ͂B
    UserList.Delete(i); // [U[j
  end
  else
  // Mf[^iT[oENCAgʁj
    CommonClientRead(s[0], s[1]);

  s.Free;
end;

procedure TMain.CommonClientRead(Cmd: String; CmdData: String);
// Socket.ReceiveText ͈xǂݏoƎ̂ŁA
// T[oENCAgʂ̏͂ŁB
begin
  if      Cmd = 'Message' then // bZ[W\
    Memo1.Lines.Add(CmdData) 
  else if Cmd = 'UserList' then // [U[ꗗXV
    UserList.CommaText := CmdData
  else
Memo1.Lines.Add(Cmd + ', ' + CmdData);
end;

procedure TMain.Edit1KeyPress(Sender: TObject; var Key: Char);
// bZ[W͗ɃL[͂Ƃ
var
  s: String;
begin 
  if Key = #13 then // ̓L[Enteȑꍇ
  begin
    s := E_UsrN.Text + ' : ' + Edit1.Text;

    // T[o[hȂ
    if ServerSocket.Active then
    begin
      // ҂ƃbZ[W\
      Memo1.Lines.Add(s);
      // ҂ƃbZ[WSNCAgɑM
      SendClient('Message', s);
      Edit1.Text := ''; // MbZ[W͏
    end
    else
    // NCAg[hȂ
    if ClientSocket.Active then
    begin 
      // ҂ƃbZ[WT[oɑM
      SendServer('Message', s);
      Edit1.Text := ''; // MbZ[W͏
    end;
  end;
end;

procedure TMain.E_UsrNExit(Sender: TObject);
begin
  // T[o[hȂ
  if ServerSocket.Active then
  begin 
    // [U[ꗗXV
    UserList.Strings[0] := E_UsrN.Text;
    // V[U[ꗗSNCAgɑM
    SendClient('UserList', UserList.CommaText);
  end
  else
  // NCAg[hȂ
  if ClientSocket.Active then 
  begin
    // V[U[T[oɑM
    SendServer('ReNameUser', E_UsrN.Text);
  end;
end;

procedure TMain.E_UsrNKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    E_UsrN.OnExit(Sender);
  end;
end;

procedure TMain.C_GMSelect(Sender: TObject);
// GMIAT[o[hł̂ݗL
var
  i: Integer;
begin
  // GMw肪T[oł
  if C_GM.ItemIndex = 0 then
  begin
    // T[oGM[h
    PlayMode.Enabled := True;
    // NCAgvC[[h
    SendClient('GMMode', 'False');
  end
  else
  // GMw肪NCAgł
  if C_GM.ItemIndex > 0 then
  begin
    // T[ovC[[h
    PlayMode.Enabled := False;
    for i := 0 to ServerSocket.Socket.ActiveConnections - 1 do
      // w̃NCAgł
      if ServerSocket.Socket.Connections[i].SocketHandle
          = StrToInt(UserHndl.Strings[C_GM.ItemIndex]) then
        // GM[h
        ServerSocket.Socket.Connections[i].SendText('GMMode, True')
      // ̃NCAgł
      else
        // vC[[h
        ServerSocket.Socket.Connections[i].SendText('GMMode, False');
  end;
  Sleep(Zzz); // R}h𕪂邽߂ɊԊu󂯂
  SendClient('GMUser', IntToStr(C_GM.ItemIndex));
end;

procedure TMain.PlayModeUpdate(Sender: TObject);
// TRPG[hAA^CŊĎ
begin
  //
  MasterScreen.Visible
    := (Sender as TAction).Checked and (Sender as TAction).Enabled;
  // TRPG[h̕\
  StatusBar1.Panels[1].Text
    := SttsPlay[Ord((Sender as TAction).Enabled)];
end;

procedure TMain.PlayModeExecute(Sender: TObject);
begin
  (Sender as TAction).Checked := not (Sender as TAction).Checked;
end;

end.
